//Declare Array
var cards = [];
var cardNum;
var kings;
var rules = 
//0
[{  "title" : "New Game!",
    "description" : "Press the card to start.."
},
//1
{   "title" : "Waterfall!",
    "description" : "Everyone start drinking until the person to your right stops, starting with the person that drew this card."
},
//2
{   "title" : "One for You!",
    "description" : "Pick someone to take a drink."
},
//3
{   "title" : "One for Me!",
    "description" : "Take a drink yourself."
},
//4
{   "title" : "Floor!",
    "description" : "The last person to touch the floor loses."
},
//5
{   "title" : "Guys!",
    "description" : "Every guy takes a drink."
},
//6
{   "title" : "Chicks!",
    "description" : "Every girl takes a drink."
},
//7
{   "title" : "Heaven!",
    "description" : "Last person to raise both hands takes a drink."
},
//8
{   "title" : "Mate!",
    "description" : "Pick a mate to drink every time you do (You don't have to drink with them)."
},
//9
{   "title" : "Rhyme!",
    "description" : "Pick a word to rhyme with then continue clockwise. First person to forget loses. (No unrhymable words!)"
},
//10
{   "title" : "Categories!",
    "description" : "Pick a category and go around the circle. E.g: Fruit - Apple, Orange, etc."
},
//11
{   "title" : "Make a Rule!",
    "description" : "Make a rule, whoever breaks the rule takes a drink. E.g. No eye contact with Joe, etc."
},
//12
{   "title" : "Question Master!",
    "description" : "Whoever answers your question must take a drink. There can only be one."
},
//13
{   "title" : "In the Cup!",
    "description" : "Poor some (or all) of your drink in the King Cup. If you draw the fourth King, you drink it!"
}];


$(document).ready(function(){
    // Set card size
    $(".card").css("height", $("#game").height()*0.7);
    $(".card").css({
        "width" : Math.round($(".card").height()*(2.5/3.5)),
        "margin-top" : ($("#game").height() - $(".card").height())*0.1
    });
    $(".cardInset").css({
        "height" : $(".card").height()-20,
        "width" : $(".card").width()-20
    });
    // Set rule size
    $("#ruleBlock").css("height", ($("#game").height() - $(".card").height() - $(".titleBar").height())/2);
    
    // Refresh Game
    resetCards();
    
    // Listener for reset button
    $("#reset").click(function() {
        $("#resetGame").popup("open")
    });
    
    // Reset array listener
    $(".card").click(function(){
        cardNum = Math.floor(Math.random()*cards.length);
        drawCard(cardNum);
    });
    
    // Close Popup Listener
    $(".closePopup").click(function(){
        $("#endGame").popup("close");
        $("#resetGame").popup("close");
        resetCards();
    });
});

// On card press, run logic
function drawCard(){
    //Declare variables for number and suit
    var drawnNum = cards[cardNum].substring(1,3);
    var drawnPic = cards[cardNum].substring(3,4);
    var royalCard;
    var cardColor;
    
    // Determine royal card
    if ( drawnNum == "11" || drawnNum == "12" || drawnNum == "13") {
        royalCard = true;
    } else {
        royalCard = false;
    };
    
    // Determine card color
    if ( drawnPic == "D" || drawnPic == "H" ) {
        cardColor = "R";
    } else {
        cardColor = "B";
    };
        
    //Remove drawn card from the array
    cards.splice(cardNum,1);
    
    // Fill default rule block
    $("#ruleTitle").text(rules[drawnNum*1].title);
    $("#ruleDesc").text(rules[drawnNum*1].description);
    
    // Remove old classes
    $("#tl-num, #tl-pic, #cen-pic, #br-pic, #br-num").removeClass();
    
    // Add classes
    // Top-left/Bottom-right picture classes
    $("#tl-pic, #br-pic").addClass(drawnPic);
    $("#tl-num, #br-num").addClass("n"+drawnNum);
    
    // Center image + top-left/bottom-right images
    if ( royalCard ) {
        $("#cen-pic").addClass(cardColor+drawnNum);
    } else {
        $("#cen-pic").addClass(drawnPic+drawnNum);
    };
    
    // King counter
    if ( (drawnNum * 1) == 13 ){
        if( kings >= 3 ){
            console.log("Game over");
            $("#endGame").popup( "open" )
            //alert("You drew the last king!\nDown the Kings Cup and press anywhere to start again.");
        }else{
            kings++;
        };
    };
    
    //Debug
    console.log( "Card number = " + drawnNum + " \nCard suit = " + drawnPic + "\nCard color = " + cardColor + "\nIs face card? " + royalCard );
};

// Reset function
function resetCards(){
    // Empty array
    cards.length = 0
    
    // Fill array
    cards.splice( 0 , 0 , "#01D" , "#02D" , "#03D" , "#04D" , "#05D" , "#06D" , "#07D" , "#08D" , "#09D" , "#10D" , "#11D" , "#12D" , "#13D" , "#01H" , "#02H" , "#03H" , "#04H" , "#05H" , "#06H" , "#07H" , "#08H" , "#09H" , "#10H" , "#11H" , "#12H" , "#13H" , "#01S" , "#02S" , "#03S" , "#04S" , "#05S" , "#06S" , "#07S" , "#08S" , "#09S" , "#10S" , "#11S" , "#12S" , "#13S" , "#01C" , "#02C" , "#03C" , "#04C" , "#05C" , "#06C" , "#07C" , "#08C" , "#09C" , "#10C" , "#11C" , "#12C" , "#13C" );

    // Reset King count
    kings = 0;
    
    // Fill default rule block
    $("#ruleTitle").text(rules[0].title);
    $("#ruleDesc").text(rules[0].description);
    
    // Reset classes
    $("#tl-num, #tl-pic, #cen-pic, #br-pic, #br-num").removeClass();
    $("#cen-pic").addClass("default");
};